#include <bits/stdc++.h>
using namespace std;

int main() {
	string s;
	cin >> s;
    int q;
    cin >> q;
    int a, b;
    vector<int> l, r;
    l.push_back(1);
    for (int i = 0; i < s.size(); i++){
        if (i > 0 && s[i] < s[i - 1]){
            r.push_back(i);
            if (i != s.size() - 1)
                l.push_back(i + 1);
        }
    }
    for (int i = 0; i < q; i++){
        cin >> a >> b;
        int up = upper_bound(l.begin(), l.end(), a) - l.begin();
        int low = lower_bound(r.begin(), r.end(), b) - r.begin();
        cout << low - up + 2 << endl;
    }
}